/*
 * StartComponentsPanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.adl;

import com.markuspage.markus.tbn.module1.adl.ADLDataObject;
import com.markuspage.markus.tbn.module1.adl.model.StartComponents;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.text.JTextComponent;
import org.netbeans.modules.xml.multiview.ui.SectionInnerPanel;
import org.netbeans.modules.xml.multiview.ui.SectionView;

/**
 *
 * @author  markus
 */
public class StartComponentsPanel extends SectionInnerPanel {

    private StartComponents component;
    private ADLDataObject dObj;

    public StartComponentsPanel(SectionView view, ADLDataObject dObj, StartComponents factory) {
        super(view);
        this.dObj = dObj;
        this.component = factory;
        initComponents();
        //jTextFieldName.setText(factory.getChannelName());
        //addValidatee(jTextFieldName);
        jList1.setListData(factory.getComponentName());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jButtonAdd = new javax.swing.JButton();
        jButtonEdit = new javax.swing.JButton();
        jButtonRemove = new javax.swing.JButton();
        jButtonUp = new javax.swing.JButton();
        jButtonDown = new javax.swing.JButton();

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(jList1);

        jButtonAdd.setText(org.openide.util.NbBundle.getMessage(StartComponentsPanel.class, "StartComponentsPanel.jButtonAdd.text")); // NOI18N
        jButtonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddActionPerformed(evt);
            }
        });

        jButtonEdit.setText(org.openide.util.NbBundle.getMessage(StartComponentsPanel.class, "StartComponentsPanel.jButtonEdit.text")); // NOI18N
        jButtonEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEditActionPerformed(evt);
            }
        });

        jButtonRemove.setText(org.openide.util.NbBundle.getMessage(StartComponentsPanel.class, "StartComponentsPanel.jButtonRemove.text")); // NOI18N
        jButtonRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveActionPerformed(evt);
            }
        });

        jButtonUp.setText(org.openide.util.NbBundle.getMessage(StartComponentsPanel.class, "StartComponentsPanel.jButtonUp.text")); // NOI18N
        jButtonUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUpActionPerformed(evt);
            }
        });

        jButtonDown.setText(org.openide.util.NbBundle.getMessage(StartComponentsPanel.class, "StartComponentsPanel.jButtonDown.text")); // NOI18N
        jButtonDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDownActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 562, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButtonAdd, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
                    .add(jButtonEdit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
                    .add(jButtonRemove, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButtonDown, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButtonUp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {jButtonAdd, jButtonEdit, jButtonRemove}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(jButtonAdd)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButtonEdit)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButtonRemove)
                        .add(18, 18, 18)
                        .add(jButtonUp)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButtonDown)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    private void jButtonAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddActionPerformed

        String newValue = JOptionPane.showInputDialog("Add component name to start list:");
        component.addComponentName(newValue);
        dObj.modelUpdatedFromUI();
        jList1.setListData(component.getComponentName());
    }//GEN-LAST:event_jButtonAddActionPerformed

    private void jButtonEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEditActionPerformed
        String value = (String) jList1.getSelectedValue();
        int index = jList1.getSelectedIndex();
        if (value == null) {
            return;
        }
        value = JOptionPane.showInputDialog("Edit component name:", value);
        component.setComponentName(index, value);
        dObj.modelUpdatedFromUI();
        jList1.setListData(component.getComponentName());
    }//GEN-LAST:event_jButtonEditActionPerformed

    private void jButtonRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveActionPerformed
        String value = (String) jList1.getSelectedValue();
        if (value == null) {
            return;
        }
        component.removeComponentName(value);
        dObj.modelUpdatedFromUI();
        jList1.setListData(component.getComponentName());
    }//GEN-LAST:event_jButtonRemoveActionPerformed

    private void jButtonUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpActionPerformed
        String[] array = component.getComponentName();

        int index = jList1.getSelectedIndex();
        if (index < 1) {
            return;
        }
        String tmp = array[index - 1];
        array[index - 1] = array[index];
        array[index] = tmp;
        component.setComponentName(array);
        dObj.modelUpdatedFromUI();
        jList1.setListData(component.getComponentName());
    }//GEN-LAST:event_jButtonUpActionPerformed

    private void jButtonDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDownActionPerformed
        String[] array = component.getComponentName();

        int index = jList1.getSelectedIndex();
        if (index < 0 || index >= array.length - 1) {
            return;
        }

        String tmp = array[index + 1];
        array[index + 1] = array[index];
        array[index] = tmp;
        component.setComponentName(array);
        dObj.modelUpdatedFromUI();
        jList1.setListData(component.getComponentName());
    }//GEN-LAST:event_jButtonDownActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAdd;
    private javax.swing.JButton jButtonDown;
    private javax.swing.JButton jButtonEdit;
    private javax.swing.JButton jButtonRemove;
    private javax.swing.JButton jButtonUp;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
    @Override
    public void setValue(JComponent source, Object value) {

        /*if(source == jTextFieldName) {
        component.setChannelName((String)value);
        } else {
        System.out.println("setValue for component: "+source+" with value "+value);
        }*/
    }

    @Override
    public void documentChanged(JTextComponent comp, String value) {

        /*if(comp == jTextFieldName) {
        String val = (String)value;
        if(val.length() == 0) {
        getSectionView().getErrorPanel().setError(new org.netbeans.modules.xml.multiview.Error(org.netbeans.modules.xml.multiview.Error.MISSING_VALUE_MESSAGE, "name", comp));
        return;
        }
        getSectionView().getErrorPanel().clearError();
        }*/

    // TODO componentClass?
    }

    @Override
    public void rollbackValue(JTextComponent source) {

        /*if(source == jTextFieldName) {
        jTextFieldName.setText(component.getChannelName());
        } */

    // TODO componentClass?
    }

    /*@Override
    protected void signalUIChange() {
        dObj.modelUpdatedFromUI();
    }*/

    public void linkButtonPressed(Object arg0, String arg1) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public JComponent getErrorComponent(String errorId) {
        /* if ("name".equals(errorId)) {
        return jTextFieldName;
        }
        // TODO componentName
         */
        return null;
    }
}
