/*
 * SubscriptionPanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.adl;

import com.markuspage.markus.tbn.module1.adl.ADLDataObject;
import com.markuspage.markus.tbn.module1.adl.model.Subscription;
import javax.swing.JComponent;
import javax.swing.text.JTextComponent;
import org.netbeans.modules.xml.multiview.ui.SectionInnerPanel;
import org.netbeans.modules.xml.multiview.ui.SectionView;

/**
 *
 * @author  markus
 */
public class SubscriptionPanel extends SectionInnerPanel {

    private Subscription component;
    private ADLDataObject dObj;

    public SubscriptionPanel(SectionView view, ADLDataObject dObj, Subscription factory) {
        super(view);
        this.dObj = dObj;
        this.component = factory;
        initComponents();
        jTextFieldComponentName.setText(factory.getComponentName());
        addValidatee(jTextFieldComponentName);
        jTextFieldChannelName.setText(factory.getChannelName());
        addValidatee(jTextFieldChannelName);
        jTextFieldHandlerName.setText(factory.getHandlerName());
        addValidatee(jTextFieldHandlerName);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldComponentName = new javax.swing.JTextField();
        jTextFieldChannelName = new javax.swing.JTextField();
        jTextFieldHandlerName = new javax.swing.JTextField();

        jLabel1.setText(org.openide.util.NbBundle.getMessage(SubscriptionPanel.class, "SubscriptionPanel.jLabel1.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextFieldComponentName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldChannelName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldHandlerName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldComponentName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldChannelName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldHandlerName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextFieldChannelName;
    private javax.swing.JTextField jTextFieldComponentName;
    private javax.swing.JTextField jTextFieldHandlerName;
    // End of variables declaration//GEN-END:variables
    
    @Override
    public void setValue(JComponent source, Object value) {

        if (source == jTextFieldComponentName) {
            component.setComponentName((String) value);
        } else if (source == jTextFieldChannelName) {
            component.setChannelName((String) value);
        } else if (source == jTextFieldHandlerName) {
            component.setHandlerName((String) value);
        }
    }

    @Override
    public void documentChanged(JTextComponent comp, String value) {

        if (comp == jTextFieldComponentName) {
            String val = value;
            if (val.length() == 0) {
                getSectionView().getErrorPanel().setError(new org.netbeans.modules.xml.multiview.Error(org.netbeans.modules.xml.multiview.Error.MISSING_VALUE_MESSAGE, "name", comp));
                return;
            }
            getSectionView().getErrorPanel().clearError();
        }

    // TODO componentClass?
    }

    @Override
    public void rollbackValue(JTextComponent source) {

        if (source == jTextFieldComponentName) {
            jTextFieldComponentName.setText(component.getComponentName());
        } else if (source == jTextFieldChannelName) {
            jTextFieldChannelName.setText(component.getChannelName());
        } else if (source == jTextFieldHandlerName) {
            jTextFieldHandlerName.setText(component.getHandlerName());
        }
    }

    /*@Override
    protected void signalUIChange() {
        dObj.modelUpdatedFromUI();
    }*/

    public void linkButtonPressed(Object arg0, String arg1) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public JComponent getErrorComponent(String errorId) {
        if ("name".equals(errorId)) {
            return jTextFieldComponentName;
        }
        // TODO componentName

        return null;
    }
}
