/*
 * ClassTemplate.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.code3;

import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataObject;

/**
 *
 * @author markus
 */
public class ClassTemplate {
    private Set<String> imports = new HashSet<String>();
    private LinkedList<String> methods = new LinkedList<String>();
    private Map<String,Object> map = new HashMap<String, Object>();

    private String fileName;
    
    public ClassTemplate(String fileName, String templateType, String name, String packagePath) {
        this.fileName = fileName;
        map.put("templateType", templateType);
        map.put("name", name);
        map.put("package", packagePath);
    }

    
    public void addImport(String packagePath) {
        imports.add(packagePath);
    }
    
    public void addMethod(String method) {
        methods.add(method);
    }

    public DataObject create(DataFolder targetFolder, DataObject template) throws IOException {
        map.put("imports", imports.toArray());
        map.put("methods", methods.toArray());
        return template.createFromTemplate(targetFolder, fileName, map);
    }
    
    public Map<String,Object> getProperties() {
        return map;
    }
}
