/*
 * NodePanel.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.topology;

import com.markuspage.markus.tbn.module1.topology.model.*;

import javax.swing.JComponent;
import javax.swing.text.JTextComponent;
import org.netbeans.modules.xml.multiview.ui.SectionInnerPanel;
import org.netbeans.modules.xml.multiview.ui.SectionView;

/**
 *
 * @author  markus
 */
public class NodePanel extends SectionInnerPanel {

    Node factory;
    TopologyDataObject dObj;
    
    public NodePanel(SectionView view, TopologyDataObject dObj, Node factory) {
        super(view);
        this.dObj=dObj;
        this.factory=factory;
        initComponents();
        
        jTextFieldId.setText(factory.getAttributeValue("id"));
        addValidatee(jTextFieldId);
        jTextFieldIp.setText(factory.getAttributeValue("ip"));
        addValidatee(jTextFieldIp);
        jTextFieldPort.setText(factory.getAttributeValue("port"));
        addValidatee(jTextFieldPort);
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldId = new javax.swing.JTextField();
        jTextFieldIp = new javax.swing.JTextField();
        jTextFieldPort = new javax.swing.JTextField();

        jLabel1.setText(org.openide.util.NbBundle.getMessage(NodePanel.class, "NodePanel.jLabel1.text")); // NOI18N

        jTextFieldId.setText(org.openide.util.NbBundle.getMessage(NodePanel.class, "NodePanel.jTextFieldId.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextFieldId, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldIp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(jTextFieldPort, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldId, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldIp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldPort, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextFieldId;
    private javax.swing.JTextField jTextFieldIp;
    private javax.swing.JTextField jTextFieldPort;
    // End of variables declaration//GEN-END:variables

    @Override
    public void setValue(JComponent source, Object value) {
        
        if(source == jTextFieldId) {
            factory.setAttributeValue("id", (String)value);
            System.out.println("setting attribute id to "+value);
        } else if(source == jTextFieldIp) {
            factory.setAttributeValue("ip", (String)value);
        } else if(source == jTextFieldPort) {
            factory.setAttributeValue("port", (String)value);
        }
    }

    @Override
    public void documentChanged(JTextComponent comp, String value) {
        
        if(comp == jTextFieldId) {

            if(value.length() == 0) {
                getSectionView().getErrorPanel().setError(new org.netbeans.modules.xml.multiview.Error(org.netbeans.modules.xml.multiview.Error.MISSING_VALUE_MESSAGE, "id", comp));
                return;
            }
            getSectionView().getErrorPanel().clearError();
        }
        
        System.out.println("Document changed: "+comp);
        
        // TODO componentClass?
    }

    @Override
    public void rollbackValue(JTextComponent source) {

        
        if(source == jTextFieldId) {
            jTextFieldId.setText(factory.getAttributeValue("id"));
        } else if(source == jTextFieldIp) {
            jTextFieldIp.setText(factory.getAttributeValue("ip"));
        } else if(source == jTextFieldPort) {
            jTextFieldPort.setText(factory.getAttributeValue("port"));
        } 
        
        // TODO componentClass?
    }

    /*@Override
    protected void signalUIChange() {
        dObj.modelUpdatedFromUI();
    }*/
    
    

    public void linkButtonPressed(Object arg0, String arg1) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public JComponent getErrorComponent(String errorId) {
        if ("id".equals(errorId)) {
            return jTextFieldId;
        }
        // TODO componentClass?
        
        return null;
    }
    
}
