/*
 * PanelFactory.java
 * 
 * 
 * Copyright (C) 2008 Markus Kilås
 *  
 * This file is part of TBN NetBeans Module.
 *
 * TBN NetBeans Module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TBN NetBeans Module is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TBN NetBeans Module.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.markuspage.markus.tbn.module1.topology;

import com.markuspage.markus.tbn.module1.topology.model.Node;
import com.markuspage.markus.tbn.module1.topology.model.Link;

import com.markuspage.markus.tbn.module1.topology.model.Topology;
import org.netbeans.modules.xml.multiview.ui.InnerPanelFactory;
import org.netbeans.modules.xml.multiview.ui.SectionInnerPanel;
import org.netbeans.modules.xml.multiview.ui.SectionView;
import org.netbeans.modules.xml.multiview.ui.ToolBarDesignEditor;

/**
 *
 * @author markus
 */
public class PanelFactory implements InnerPanelFactory {

    private TopologyDataObject dObj;
    ToolBarDesignEditor editor;

    public PanelFactory(ToolBarDesignEditor editor, TopologyDataObject dObj) {
        this.dObj = dObj;
        this.editor = editor;
    }

    public SectionInnerPanel createInnerPanel(Object key) {
        if (key instanceof Node) {
            return new NodePanel((SectionView) editor.getContentView(), dObj, (Node) key);
        } else if (key instanceof Link) {
            return new LinkPanel((SectionView) editor.getContentView(), dObj, (Link) key);
        } else {
            return new TopologyPanel((SectionView) editor.getContentView(), dObj, (Topology) key);
        }
    }
}
